VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Cdigo del Mdulo de clase: Class1

'#############################################



'Variables locales
Private flag As Boolean
Private Posx As Single

'Ancho y alto del control Picture
Private Ancho As Single
Private Alto As Single

'Variables locales para los colores
Private m_ColorSlider As Long
Private m_ColorContorno As Long
Private m_ColorFondo As Long

Private m_Max As Integer
Private m_Value As Integer


' Tamao del grosor de la barra y del grosor del contorno del slider
Private m_sizeBarra As Byte
Private m_SizeContorno As Byte

'Variable de tipo Picture con evento
Private WithEvents UnPicture As PictureBox
Attribute UnPicture.VB_VarHelpID = -1

'Enum para la posicin del Slider: Normal, abajo o arriba
Enum E_Estilo

[ ENormal ] = 0
[ ETop ] = 1
[ EBottom ] = 2

End Enum

Private m_Estilo As E_Estilo

'Evento que se dispara al cambiar el valor
Public Event ChangeValue()



'Inicio y finalizacin
'########################################################


'Recibe como parmetro el control PictureBox
Sub Iniciar(UnPictureBox As PictureBox)

'Si ya est creado salimos
If Not UnPicture Is Nothing Then
   Exit Sub
End If
    
    'Si no est creado lo asignamos
    Set UnPicture = UnPictureBox
    
    With UnPicture
        
        'Ancho y alto del Picture
        Ancho = .ScaleWidth
        Alto = .ScaleHeight
            
        .BackColor = vbBlack

        Dibujar_Contorno
    End With

End Sub

Private Sub Class_Initialize()
    
    'Valores por defecto
    m_SizeContorno = 10
    m_sizeBarra = 5
    m_ColorContorno = vbRed
    m_ColorSlider = vbGreen
    m_Estilo = [ ETop ]
End Sub

'Elimina el objeto Picture
Private Sub Class_Terminate()
If Not UnPicture Is Nothing Then
   Set UnPicture = Nothing
End If
End Sub




'Eventos MouseMove, MouseUp y MouseDown locales del control Picturebox
'######################################################################

Private Sub UnPicture_MouseDown(Button As Integer, Shift As Integer, _
                                            X As Single, Y As Single)

Static flag2 As Boolean

    flag = True
    
    If flag2 Then
       UnPicture.Cls
    Else
        flag2 = True
    End If
    Posx = X
    
    If Posx < 0 Then
        Posx = 0
    ElseIf Posx > Ancho Then
        Posx = Ancho
    End If
    
    'Dibuja la barra del Slider pasandole la _
    posicin X y el alto del Picture
    
    Call Dibujar_Slider(Posx, Alto)
    
    'Dibuja el contorno
    Call Dibujar_Contorno
      
    m_Value = Format$(CInt((Posx / Ancho) * m_Max))
      
    'Lanza el evento cuando cambia el valor
    RaiseEvent ChangeValue
    UnPicture.ToolTipText = m_Value

  
End Sub


Private Sub UnPicture_MouseMove(Button As Integer, Shift As Integer, _
                                            X As Single, Y As Single)
    If Not flag Then Exit Sub
    
    'Limpia el Picture
    UnPicture.Cls
    Posx = X
    
    
    If Posx < 0 Then
        Posx = 0
    ElseIf Posx > Ancho Then
        Posx = Ancho
    End If

    ' Dibuja el slider
    Call Dibujar_Slider(Posx, Alto)
    
    'Dibuja el contorno
    Call Dibujar_Contorno
    
    m_Value = Format$(CInt((Posx / Ancho) * m_Max))
    
    'Lanza el evento y muestra el valor
    RaiseEvent ChangeValue
    UnPicture.ToolTipText = m_Value
End Sub

'Pone el Flag en False cuando se suelta el mouse para _
que en el evento MouseMove no se dispare

Private Sub UnPicture_MouseUp(Button As Integer, Shift As Integer, _
                                            X As Single, Y As Single)
    flag = False
End Sub


' Por si se redimensiona el Picture se vuelve a redibujar

Private Sub UnPicture_Resize()

With UnPicture
    Ancho = .ScaleWidth
    Alto = .ScaleHeight
    .Cls
End With

Call Dibujar_Slider(Posx, Alto)
Call Dibujar_Contorno
End Sub




'######################################################
'Sub para dibujar el contorno y la barra del Slider
'######################################################

Private Sub Dibujar_Contorno()

With UnPicture
      
     'Grosor del contorno
     .DrawWidth = m_SizeContorno
        
     ' Linea lateral izquierda
     UnPicture.Line (0, 0)-(0, .ScaleHeight), m_ColorContorno
     ' Linea lateral derecha
     UnPicture.Line (.ScaleWidth, 0)-(.ScaleWidth, .ScaleHeight), m_ColorContorno
     
     ' Linea superior
     UnPicture.Line (.ScaleWidth, 0)-(0, 0), m_ColorContorno
     ' Linea Inferior
     UnPicture.Line (.ScaleWidth, .ScaleHeight)-(0, .ScaleHeight), m_ColorContorno

End With



End Sub

Private Sub Dibujar_Slider(Posx As Single, Alto As Single)

'Grosor de la linea del Slider
UnPicture.DrawWidth = m_sizeBarra

'Depende del estilo la dibuja completa, abajo o arriba
Select Case m_Estilo

Case 0
    'Normal
    UnPicture.Line (Posx, 0)-(Posx, Alto), m_ColorSlider
Case 1
    'Superior
    UnPicture.Line (Posx, 0)-(Posx, Alto / 2), m_ColorSlider
Case 2
    'Inferior
    UnPicture.Line (Posx, Alto)-(Posx, Alto / 2), m_ColorSlider
End Select

End Sub


'########################################################################
'Propiedades Color de contorno, color del Slider, Grosor del contorno _
    Grosor de la barra
'########################################################################


'Color del contorno del Picture

Public Property Get ColorContorno() As Long
ColorContorno = m_ColorContorno
End Property

Public Property Let ColorContorno(ByVal color As Long)
m_ColorContorno = color
Dibujar_Contorno
End Property

'Color de la barra del Slider

Public Property Get ColorSlider() As Long
ColorSlider = m_ColorSlider
End Property

Public Property Let ColorSlider(ByVal color As Long)
m_ColorSlider = color
Call Dibujar_Slider(Posx, Alto)
Call Dibujar_Contorno
End Property

' Grosor del Slider y del contorno

Public Property Get sizeContorno() As Byte
sizeContorno = m_SizeContorno
End Property

Public Property Let sizeContorno(ByVal vNewValue As Byte)
    m_SizeContorno = vNewValue
    UnPicture.Cls
    Call Dibujar_Slider(Posx, Alto)
    Dibujar_Contorno
End Property

Public Property Get sizeBarra() As Byte
sizeBarra = m_sizeBarra

End Property

Public Property Let sizeBarra(ByVal vNewValue As Byte)
m_sizeBarra = vNewValue
UnPicture.Cls
Call Dibujar_Slider(Posx, Alto)
Dibujar_Contorno
End Property

'Color del fondo

Public Property Get ColorFondo() As Long
ColorFondo = UnPicture.BackColor
End Property

Public Property Let ColorFondo(ByVal vNewValue As Long)
UnPicture.BackColor = vNewValue
End Property

'Tipo de Estilo de la linea del Slider

Public Property Get Estilo() As E_Estilo
Estilo = m_Estilo
End Property

Public Property Let Estilo(ByVal vNewValue As E_Estilo)
m_Estilo = vNewValue

UnPicture.Cls

Call Dibujar_Slider(Posx, Alto)
Call Dibujar_Contorno
End Property

Public Property Get Max() As Integer
Max = m_Max
End Property

Public Property Let Max(ByVal vNewValue As Integer)
m_Max = vNewValue

End Property


Public Property Get Value() As Integer
Value = m_Value
End Property

Public Property Let Value(ByVal vNewValue As Integer)

If vNewValue > m_Max Then
   MsgBox " El valor de Value no puede ser mayor al Mximo ", vbCritical
End If

m_Value = vNewValue

UnPicture.Cls

Call Dibujar_Slider((m_Value * Ancho) / m_Max, Alto)
Call Dibujar_Contorno

RaiseEvent ChangeValue

End Property
